"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitForApplicationOfSession = exports.sleep = exports.getApplicationOfSession = exports.setApplicationOfSession = void 0;
// track the application in memory
let application = null;
const setApplicationOfSession = (set) => (application = set);
exports.setApplicationOfSession = setApplicationOfSession;
const getApplicationOfSession = () => {
    if (!application)
        throw new Error('application not set yet');
    return application;
};
exports.getApplicationOfSession = getApplicationOfSession;
const sleep = (ms) => new Promise((resolve) => setTimeout(resolve, ms));
exports.sleep = sleep;
const waitForApplicationOfSession = () => __awaiter(void 0, void 0, void 0, function* () {
    for (let attempt = 0; attempt < 5; attempt++) {
        if (application)
            return application;
        yield (0, exports.sleep)(300);
    }
    throw new Error('application wait attempts exceeded');
});
exports.waitForApplicationOfSession = waitForApplicationOfSession;
//# sourceMappingURL=getApplicationOfSession.js.map